Index: /trunk/Packages/Common/Mail.php
===================================================================
--- /trunk/Packages/Common/Mail.php	(revision 68)
+++ /trunk/Packages/Common/Mail.php	(revision 69)
@@ -13,5 +13,5 @@
   var $From;
   var $Recipients;
-  var $Bodies;	
+  var $Bodies;
   var $Attachments;
   var $AgentIdent;
@@ -19,13 +19,13 @@
   var $ReplyTo;
   var $Headers;
-  
+
   function __construct()
   {
-    $this->Priorities = array('1 (Highest)', '2 (High)', '3 (Normal)', '4 (Low)', '5 (Lowest)');           
+    $this->Priorities = array('1 (Highest)', '2 (High)', '3 (Normal)', '4 (Low)', '5 (Lowest)');
     $this->Boundary = md5(date('r', time()));
     $this->AgentIdent = 'PHP/Mail';
     $this->Clear();
   }
-  
+
   function Clear()
   {
@@ -63,5 +63,5 @@
   function AddBody($Content, $MimeType = 'text/plain', $Charset = 'utf-8')
   {
-    $this->Bodies[] = array('Content' => $Content, 'Type' => strtolower($MimeType), 
+    $this->Bodies[] = array('Content' => $Content, 'Type' => strtolower($MimeType),
       'Charset' => strtolower($Charset));
   }
@@ -75,14 +75,14 @@
   {
     if(!intval($Priority)) return(false);
-		
+
     if(!isset($this->priorities[$Priority - 1])) return(false);
 
-    $this->xheaders['X-Priority'] = $this->priorities[$Priority - 1];	
+    $this->xheaders['X-Priority'] = $this->priorities[$Priority - 1];
     return(true);
   }
 
   function AttachFile($FileName, $FileType, $Disposition = DISPOSITION_ATTACHMENT)
-  {	
-    $this->Attachments[] = array('FileName' => $FileName, 'FileType' => $FileType, 
+  {
+    $this->Attachments[] = array('FileName' => $FileName, 'FileType' => $FileType,
       'Disposition' => $Disposition, 'Type' => 'File');
   }
@@ -90,5 +90,5 @@
   function AttachData($FileName, $FileType, $Data, $Disposition = DISPOSITION_ATTACHMENT)
   {
-    $this->Attachments[] = array('FileName' => $FileName, 'FileType' => $FileType, 
+    $this->Attachments[] = array('FileName' => $FileName, 'FileType' => $FileType,
       'Disposition' => $Disposition, 'Type' => 'Data', 'Data' => $Data);
   }
@@ -96,12 +96,12 @@
   function Send()
   {
-    if(count($this->Bodies) == 0) throw new Exception('Mail: Need at least one text body');
-    
+    if(count($this->Bodies) == 0) throw new Exception(T('Mail message need at least one text body'));
+
     $Body = $this->BuildAttachment($this->BuildBody());
-    
+
     $To = '';
     $this->Headers['CC'] = '';
     $this->Headers['BCC'] = '';
-    foreach($this->Recipients as $Index => $Recipient)      
+    foreach($this->Recipients as $Index => $Recipient)
     {
       if($Recipient['Type'] == 'SendCombined')
@@ -126,8 +126,8 @@
       }
     }
-    if($To == '') throw new Exception('Mail: Need at least one recipient address');
-    
+    if($To == '') throw new Exception(T('Mail message need at least one recipient address'));
+
     $this->Headers['Mime-Version'] = '1.0';
-    
+
     if($this->AgentIdent != '') $this->Headers['X-Mailer'] = $this->AgentIdent;
     if($this->ReplyTo != '') $this->Headers['Reply-To'] = $this->ReplyTo;
@@ -135,13 +135,13 @@
 
     $Headers = '';
-    foreach($this->Headers as $Header => $Value) 
+    foreach($this->Headers as $Header => $Value)
     {
       if(($Header != 'Subject') and ($Value != '')) $Headers .= $Header.': '.$Value."\n";
-    }   
+    }
 
     $this->Subject = strtr($this->Subject, "\r\n", '  ');
 
-    if($this->Subject == '') throw new Exception('Mail: Missing Subject');
-    
+    if($this->Subject == '') throw new Exception(T('Mail message missing Subject'));
+
 
     $res = mail($To, $this->Subject, $Body, $Headers);
@@ -152,5 +152,5 @@
   {
     if(ereg(".*<(.+)>", $Address, $regs)) $Address = $regs[1];
-    if(ereg("^[^@  ]+@([a-zA-Z0-9\-]+\.)+([a-zA-Z0-9\-]{2}|net|com|gov|mil|org|edu|int)\$", $Address)) 
+    if(ereg("^[^@  ]+@([a-zA-Z0-9\-]+\.)+([a-zA-Z0-9\-]{2}|net|com|gov|mil|org|edu|int)\$", $Address))
       return(true);
       else return(false);
@@ -159,11 +159,11 @@
   function CheckAdresses($Addresses)
   {
-    foreach($Addresses as $Address) 
-    {
-      if(!$this->ValidEmail($Address)) 
-	throw new Exception('Mail: Invalid address '.$Address);
-    }
-  } 
-  
+    foreach($Addresses as $Address)
+    {
+      if(!$this->ValidEmail($Address))
+  throw new Exception(sprintf(T('Mail message invalid address %s'), $Address));
+    }
+  }
+
   private function ContentEncoding($Charset)
   {
@@ -175,11 +175,11 @@
   {
     if(count($this->Attachments) > 0)
-    {        
+    {
       $this->Headers['Content-Type'] = "multipart/mixed;\n boundary=\"PHP-mixed-".$this->Boundary."\"";
       $Result = "This is a multi-part message in MIME format.\n".
-        "--PHP-mixed-".$this->Boundary."\n";    
+        "--PHP-mixed-".$this->Boundary."\n";
       $Result .= $Body;
-    
-      foreach($this->Attachments as $Attachment) 
+
+      foreach($this->Attachments as $Attachment)
       {
         $FileName = $Attachment['FileName'];
@@ -189,11 +189,11 @@
         if($Attachment['Type'] == 'File')
         {
-          if(!file_exists($FileName)) 
-            throw new Exception('Mail: Attached file '.$FileName.' can\'t be found');
+          if(!file_exists($FileName))
+            throw new Exception(sprintf(T('Mail message attached file %s can\'t be found'), $FileName));
           $Data = file_get_contents($FileName);
-        } else 
+        } else
         if($Attachment['Type'] == 'Data') $Data = $Attachment['Data'];
           else $Data = '';
-		
+
         $Result .= "\n".'--PHP-mixed-'.$this->Boundary."\n".
           "Content-Type: ".$ContentType."; name=\"".$BaseName."\"\n".
@@ -203,16 +203,16 @@
       }
     } else $Result = $Body;
-    return($Result);    
-  }
-  
+    return($Result);
+  }
+
   private function BuildBody()
   {
     $Result = '';
-    if(count($this->Bodies) > 1) 
+    if(count($this->Bodies) > 1)
     {
       $this->Headers['Content-Type'] = 'multipart/alternative; boundary="PHP-alt-'.$this->Boundary.'"';
       $Result .= 'Content-Type: multipart/alternative; boundary="PHP-alt-'.$this->Boundary.'"'.
         "\n\n";
-    } else 
+    } else
     {
       $this->Headers['Content-Type'] = $this->Bodies[0]['Type'].'; charset='.$this->Bodies[0]['Charset'];
@@ -220,13 +220,13 @@
     }
 
-        
+
     foreach($this->Bodies as $Body)
     {
-      if(count($this->Bodies) > 1) $Result .= "\n\n".'--PHP-alt-'.$this->Boundary."\n";           
+      if(count($this->Bodies) > 1) $Result .= "\n\n".'--PHP-alt-'.$this->Boundary."\n";
       $Result .= 'Content-Type: '.$Body['Type'].'; charset='.$Body['Charset'].
-        "\nContent-Transfer-Encoding: ".$this->ContentEncoding($Body['Charset'])."\n\n".$Body['Content']."\n";          
+        "\nContent-Transfer-Encoding: ".$this->ContentEncoding($Body['Charset'])."\n\n".$Body['Content']."\n";
     }
     return($Result);
-  }  
+  }
 }
 
Index: /trunk/Packages/Common/Page.php
===================================================================
--- /trunk/Packages/Common/Page.php	(revision 69)
+++ /trunk/Packages/Common/Page.php	(revision 69)
@@ -0,0 +1,32 @@
+<?php
+
+class Page extends View
+{
+  var $Title;
+  var $ParentClass;
+  var $RawPage;
+  var $OnSystemMessage;
+
+  function __construct(System $System)
+  {
+    parent::__construct($System);
+    $this->RawPage = false;
+    $this->OnSystemMessage = array();
+  }
+
+  function Show()
+  {
+    return('');
+  }
+
+  function GetOutput()
+  {
+    $Output = $this->Show();
+    return($Output);
+  }
+
+  function SystemMessage($Title, $Text)
+  {
+    return(call_user_func_array($this->OnSystemMessage, array($Title, $Text)));
+  }
+}
Index: /trunk/Packages/Common/Setup.php
===================================================================
--- /trunk/Packages/Common/Setup.php	(revision 69)
+++ /trunk/Packages/Common/Setup.php	(revision 69)
@@ -0,0 +1,447 @@
+<?php
+
+class PageSetup extends Page
+{
+  var $UpdateManager;
+  var $ConfigDefinition;
+  var $Config;
+  var $DatabaseRevision;
+  var $Revision;
+  var $Updates;
+  var $ConfigDir;
+
+  function __construct($System)
+  {
+    parent::__construct($System);
+    $this->Title = T('Application setup');
+    //$this->ParentClass = 'PagePortal';
+    $this->ConfigDir = dirname(dirname(dirname(__FILE__))).'/Config';
+    $this->YesNo = array(false => T('No'), true => T('Yes'));
+  }
+
+  function LoginPanel()
+  {
+    $Output = '<h3>Přihlášení k instalaci</h3>'.
+      '<form action="?" method="post">'.
+      '<table>'.
+      '<tr><td>Systémové heslo:</td><td> <input type="password" name="SystemPassword" value=""/></td></tr>'.
+      '</table>'.
+      '<input type="submit" name="login" value="'.T('Login').'"/>'.
+      '</form>';
+    return($Output);
+  }
+
+  function ControlPanel()
+  {
+    $Output = '<h3>'.T('Instance management').'</h3>';
+
+    $Output .= 'Je připojení k databázi: '.$this->YesNo[$this->UpdateManager->Database->Connected()].'<br/>';
+    if($this->UpdateManager->Database->Connected())
+    {
+      $Output .= 'Je instalováno: '.$this->YesNo[$this->UpdateManager->IsInstalled()].'<br/>';
+      if($this->UpdateManager->IsInstalled())
+        $Output .= 'Je aktuální: '.$this->YesNo[$this->UpdateManager->IsUpToDate()].'<br/>'.
+        'Verze databáze: '.$this->UpdateManager->GetDbVersion().'<br/>';
+      $Output .= 'Verze databáze kódu: '.$this->UpdateManager->Revision.'<br/>';
+      if($this->UpdateManager->IsInstalled())
+      {
+        if(!$this->UpdateManager->IsUpToDate())
+          $Output .= '<a href="?action=upgrade">'.T('Upgrade').'</a> ';
+        $Output .= '<a href="?action=insert_sample_data">Vložit vzorová data</a> ';
+        $Output .= '<a href="?action=reload_modules">Obnovit seznam modulů</a> ';
+        $Output .= '<a href="?action=uninstall">Odinstalovat</a> ';
+        $Output .= '<a href="?action=modules">Správa modulů</a> ';
+        $Output .= '<a href="?action=models">Přegenerovat modely</a> ';
+      } else $Output .= '<a href="?action=install">Instalovat</a> ';
+    }
+    $Output .= '<a href="?action=configure">Nastavit</a> ';
+    $Output .= '<a href="?action=logout">Odhlásit</a> ';
+    $Output .= '<a href="'.$this->System->Link('/').'">'.T('Go to main page').'</a> ';
+    $Output .= '';
+    return($Output);
+  }
+
+  function Show()
+  {
+    global $ConfigDefinition, $DatabaseRevision, $Config, $Updates;
+
+    $this->UpdateManager = $this->System->Setup->UpdateManager;
+    $DefaultConfig = new DefaultConfig();
+    $this->ConfigDefinition = $DefaultConfig->Get();
+    $this->DatabaseRevision = $DatabaseRevision;
+    $this->Config = &$Config;
+
+    $Output = '';
+    if(isset($this->Config))
+    {
+      if(!array_key_exists('SystemPassword', $_SESSION)) $_SESSION['SystemPassword'] = '';
+      if(array_key_exists('login', $_POST)) $_SESSION['SystemPassword'] = $_POST['SystemPassword'];
+      if(sha1($_SESSION['SystemPassword']) != $this->Config['SystemPassword'])
+      {
+        $Output .= $this->LoginPanel();
+      } else
+      {
+        if(array_key_exists('action', $_GET)) $Action = $_GET['action'];
+          else $Action = '';
+        if($Action == 'logout')
+        {
+          $_SESSION['SystemPassword'] = '';
+          $Output .= 'Odhlášen';
+          $Output .= $this->LoginPanel();
+        } else
+        if($Action == 'models')
+        {
+          $this->System->FormManager->UpdateSQLMeta();
+        } else
+        if($Action == 'upgrade')
+        {
+          $Output .= '<h3>Povýšení</h3>';
+          try {
+            $Output .= $this->System->Setup->Upgrade();
+          } catch (Exception $E) {
+            $Output .= $this->SystemMessage('Chyba aktualizace',
+              'Došlo k chybě v SQL dotazu při aktualizaci: <br/>'.$E->getMessage());
+          }
+          $Output .= $this->ControlPanel();
+        } else
+        if($Action == 'install')
+        {
+          $Output .= '<h3>Instalace</h3>';
+          $this->System->Setup->Install();
+          $this->System->ModuleManager->LoadModules();
+          $this->System->ModuleManager->SaveState();
+          //$Output .= $this->System->Setup->Upgrade();
+          $Output .= $this->ControlPanel();
+        } else
+        if($Action == 'uninstall')
+        {
+          $Output .= '<h3>Odinstalace</h3>';
+          $this->System->Setup->Uninstall();
+          $Output .= $this->ControlPanel();
+        } else
+        if($Action == 'reload_modules')
+        {
+          $Output .= '<h3>Znovunačtení seznamu modulů</h3>';
+          $this->System->ModuleManager->LoadModules();
+          $this->System->ModuleManager->SaveState();
+          $Output .= $this->ControlPanel();
+        } else
+        if($Action == 'insert_sample_data')
+        {
+          $Output .= '<h3>Vložení vzorových dat</h3>';
+          $this->System->Setup->InsertSampleData();
+          $Output .= $this->ControlPanel();
+        } else
+        if($Action == 'modules')
+        {
+          $Output .= $this->ShowModules();
+        } else
+        if($Action == 'configure_save')
+        {
+           $Output .= $this->ConfigSave($this->Config);
+           $Output .= $this->ControlPanel();
+        } else
+        if($Action == 'configure')
+        {
+          $Output .= $this->PrepareConfig($this->Config);
+        } else
+        {
+          $Output .= $this->ControlPanel();
+        }
+      }
+    } else
+    {
+      if(array_key_exists('configure_save', $_POST))
+      {
+        $Output .= $this->ConfigSave(array());
+        $Output .= 'Pokračujte k přihlášení <a href="">zde</a>';
+      } else {
+        $Output .= $this->PrepareConfig(array());
+      }
+    }
+    return($Output);
+  }
+
+  function ShowModules()
+  {
+    $Output = '';
+    if(array_key_exists('op', $_GET)) $Operation = $_GET['op'];
+      else $Operation = '';
+    if($Operation == 'install')
+    {
+      $this->System->ModuleManager->Modules[$_GET['name']]->Install();
+      $this->System->ModuleManager->SaveState();
+      $Output .= 'Modul '.$_GET['name'].' instalován<br/>';
+    } else
+    if($Operation == 'uninstall')
+    {
+      $this->System->ModuleManager->Modules[$_GET['name']]->Uninstall();
+      $this->System->ModuleManager->SaveState();
+      $Output .= 'Modul '.$_GET['name'].' odinstalován<br/>';
+    } else
+    if($Operation == 'enable')
+    {
+      $this->System->ModuleManager->Modules[$_GET['name']]->Enable();
+      $this->System->ModuleManager->SaveState();
+      $Output .= 'Modul '.$_GET['name'].' povolen<br/>';
+    } else
+    if($Operation == 'disable')
+    {
+      $this->System->ModuleManager->Modules[$_GET['name']]->Disable();
+      $this->System->ModuleManager->SaveState();
+      $Output .= 'Modul '.$_GET['name'].' zakázán<br/>';
+    } else
+    if($Operation == 'upgrade')
+    {
+      $this->System->ModuleManager->Modules[$_GET['name']]->Upgrade();
+      $this->System->ModuleManager->SaveState();
+      $Output .= 'Modul '.$_GET['name'].' povýšen<br/>';
+    }
+    $Output .= '<h3>Správa modulů</h3>';
+    $Output .= $this->ShowList();
+    return($Output);
+  }
+
+  function ShowList()
+  {
+    $Output = '';
+
+    $Pageing = new Paging($this->System);
+    $Pageing->TotalCount = count($this->System->ModuleManager->Modules);
+    $Table = new VisualTable($this->System);
+    $Table->SetColumns(array(
+      array('Name' => 'Name', 'Title' => 'Jméno'),
+      array('Name' => 'Creator', 'Title' => 'Tvůrce'),
+      array('Name' => 'Version', 'Title' => 'Verze'),
+      array('Name' => 'License', 'Title' => 'Licence'),
+      array('Name' => 'Installed', 'Title' => 'Instalováno'),
+      array('Name' => 'Enabled', 'Title' => 'Povoleno'),
+      array('Name' => 'Description', 'Title' => 'Popis'),
+      array('Name' => 'Dependencies', 'Title' => 'Závislosti'),
+      array('Name' => '', 'Title' => 'Akce'),
+    ));
+    foreach($this->System->ModuleManager->Modules as $Module)
+    {
+      if(($Module->Dependencies) > 0) $Dependencies = implode(',', $Module->Dependencies);
+       else $Dependencies = '&nbsp;';
+      $Actions = '';
+      if($Module->Installed == true)
+      {
+        $Actions .= ' <a href="?action=modules&amp;op=uninstall&amp;name='.$Module->Name.'">Odinstalovat</a>';
+        if($Module->Enabled == true) $Actions .= ' <a href="?action=modules&amp;op=disable&amp;name='.$Module->Name.'">Zakázat</a>';
+        else $Actions .= ' <a href="?action=modules&amp;op=enable&amp;name='.$Module->Name.'">Povolit</a>';
+        if($Module->InstalledVersion != $Module->Version) $Actions .= ' <a href="?action=modules&amp;op=upgrade&amp;name='.$Module->Name.'">Povýšit</a>';
+      } else $Actions .= ' <a href="?action=modules&amp;op=install&amp;name='.$Module->Name.'">Instalovat</a>';
+
+      $Table->Table->Cells[] = array($Module->Name,
+        $Module->Creator, $Module->Version,
+        $Module->License, $this->YesNo[$Module->Installed],
+        $this->YesNo[$Module->Enabled], $Module->Description,
+        $Dependencies, $Actions);
+    }
+    $Output .= $Pageing->Show();
+    $Output .= $Table->Show();
+    $Output .= $Pageing->Show();
+    //$Output .= '<p><a href="?A=SaveToDb">Uložit do databáze</a></p>';
+    return($Output);
+  }
+
+  function PrepareConfig($Config)
+  {
+    $Output = '';
+    if(!file_exists($this->ConfigDir.'/Config.php') and !is_writable($this->ConfigDir))
+      $Output .= 'Varování: Konfigurační soubor nebude možné zapsat, protože složka "'.$this->ConfigDir.'" není povolená pro zápis!';
+    if(file_exists($this->ConfigDir.'/Config.php') and !is_writable($this->ConfigDir.'/Config.php'))
+      $Output .= 'Varování: Konfigurační soubor nebude možné zapsat, protože soubor "'.$this->ConfigDir.'/Config.php" není povolen pro zápis!';
+    $Output .= '<h3>Nastavení systému</h3>'.
+        '<form action="?action=configure_save" method="post">'.
+        '<table>';
+    foreach($this->ConfigDefinition as $Def)
+    {
+      $PathParts = explode('/', $Def['Name']);
+      $TempConfig = &$Config;
+      foreach($PathParts as $Part)
+        if(array_key_exists($Part, $TempConfig))
+        {
+          $TempConfig = &$TempConfig[$Part];
+        }
+      if(!is_array($TempConfig)) $Value = $TempConfig;
+        else $Value = $Def['Default'];
+      $Output .= '<tr><td>'.$Def['Title'].'</td><td>';
+      if($Def['Type'] == 'String') $Output .= '<input type="text" name="'.$Def['Name'].'" value="'.$Value.'"/>';
+      if($Def['Type'] == 'Password') $Output .= '<input type="password" name="'.$Def['Name'].'"/>';
+      if($Def['Type'] == 'PasswordEncoded') $Output .= '<input type="password" name="'.$Def['Name'].'"/>';
+      if($Def['Type'] == 'Integer') $Output .= '<input type="text" name="'.$Def['Name'].'" value="'.$Value.'"/>';
+      if($Def['Type'] == 'Float') $Output .= '<input type="text" name="'.$Def['Name'].'" value="'.$Value.'"/>';
+      if($Def['Type'] == 'Boolean') $Output .= '<input type="text" name="'.$Def['Name'].'" value="'.$Value.'"/>';
+      if($Def['Type'] == 'Array') $Output .= '<input type="text" name="'.$Def['Name'].'" value="'.implode(',', $Value).'"/>';
+    }
+    $Output .= '</td></tr>'.
+        '<tr><td colspan="2"><input type="submit" name="configure_save" value="'.T('Save').'"/></td></tr>'.
+        '</table>'.
+        '</form>';
+    return($Output);
+  }
+
+  function ConfigSave($DefaultConfig)
+  {
+    $Config = $DefaultConfig;
+    foreach($this->ConfigDefinition as $Def)
+    {
+      $Value = null;
+      if($Def['Type'] == 'String') if(array_key_exists($Def['Name'], $_POST))
+        $Value = $_POST[$Def['Name']];
+      if($Def['Type'] == 'Password') if(array_key_exists($Def['Name'], $_POST) and ($_POST[$Def['Name']] != ''))
+        $Value = $_POST[$Def['Name']];
+      if($Def['Type'] == 'PasswordEncoded') if(array_key_exists($Def['Name'], $_POST) and ($_POST[$Def['Name']] != ''))
+        $Value = sha1($_POST[$Def['Name']]);
+      if($Def['Type'] == 'Integer') if(array_key_exists($Def['Name'], $_POST))
+        $Value = $_POST[$Def['Name']];
+      if($Def['Type'] == 'Float') if(array_key_exists($Def['Name'], $_POST))
+        $Value = $_POST[$Def['Name']];
+      if($Def['Type'] == 'Boolean') if(array_key_exists($Def['Name'], $_POST))
+        $Value = $_POST[$Def['Name']];
+      if($Def['Type'] == 'Array') if(array_key_exists($Def['Name'], $_POST))
+        $Value = explode(',', $_POST[$Def['Name']]);
+      if(!is_null($Value))
+      {
+        $PathParts = explode('/', $Def['Name']);
+        $TempConfig = &$Config;
+        foreach($PathParts as $Part)
+        {
+          $TempConfig = &$TempConfig[$Part];
+        }
+        if(!is_array($TempConfig)) $TempConfig = $Value;
+        else $Value = $Def['Default'];
+      }
+    }
+    $ConfigText = $this->CreateConfig($Config);
+    file_put_contents($this->ConfigDir.'/Config.php', $ConfigText);
+    $Output = 'Konfigurace nastavena<br/>';
+    return($Output);
+  }
+
+  function CreateConfig($Config)
+  {
+    $Output = "<?php\n\n".
+      "\$IsDeveloper = array_key_exists('REMOTE_ADDR', \$_SERVER) and  in_array(\$_SERVER['REMOTE_ADDR'], array('127.0.0.1'));\n\n";
+
+    foreach($this->ConfigDefinition as $Def)
+    {
+      $PathParts = explode('/', $Def['Name']);
+      $Output .= "\$Config";
+      foreach($PathParts as $Part)
+        $Output .= "['".$Part."']";
+      $TempConfig = &$Config;
+      $Output .= ' = ';
+      foreach($PathParts as $Part)
+        if(array_key_exists($Part, $TempConfig))
+        {
+          $TempConfig = &$TempConfig[$Part];
+        }
+      if(!is_array($TempConfig)) $Value = $TempConfig;
+        else $Value = $Def['Default'];
+      if($Def['Type'] == 'Array')
+      {
+        $Output .= ' array(';
+        foreach($Value as $Index => $Item)
+          $Output .= '\''.$Item.'\', ';
+        $Output .= ')';
+      }
+      else $Output .= "'".$Value."'";
+      $Output .= ";\n";
+    }
+    $Output .= "\n\n";
+    return($Output);
+  }
+}
+
+class PageSetupRedirect extends Page
+{
+  function Show()
+  {
+    $Output = '';
+    if(!$this->Database->Connected()) $Output .= T('Can\'t connect to database').'<br>';
+    else {
+      if(!$this->System->Setup->UpdateManager->IsInstalled())
+        $Output .= T('System requires database initialization').'<br>';
+      else
+      if(!$this->System->Setup->UpdateManager->IsUpToDate())
+        $Output .= T('System requires database upgrade').'<br>';
+    }
+    $Output .= sprintf(T('Front page was not configured. Continue to %s'), '<a href="'.$this->System->Link('/setup/').'">'.T('setup').'</a>');
+    return($Output);
+  }
+}
+
+class Setup extends Model
+{
+  var $UpdateManager;
+
+  function Start()
+  {
+    global $DatabaseRevision;
+
+    $this->System->RegisterPage('', 'PageSetupRedirect');
+    $this->System->RegisterPage('setup', 'PageSetup');
+
+    // Check database persistence structure
+    $this->UpdateManager = new UpdateManager();
+    $this->UpdateManager->Database = &$this->Database;
+    $this->UpdateManager->Revision = $DatabaseRevision;
+    $this->UpdateManager->InstallMethod = 'FullInstall';
+  }
+
+  function Stop()
+  {
+    unset($this->UpdateManager);
+    $this->System->UnregisterPage('');
+    $this->System->UnregisterPage('setup');
+  }
+
+  function CheckState()
+  {
+    return($this->Database->Connected() and $this->UpdateManager->IsInstalled() and
+      $this->UpdateManager->IsUpToDate());
+  }
+
+  function Install()
+  {
+    global $DatabaseRevision;
+
+    $this->Database->query('CREATE TABLE IF NOT EXISTS `'.$this->UpdateManager->VersionTable.'` (
+  `Id` int(11) NOT NULL AUTO_INCREMENT,
+  `Revision` int(11) NOT NULL,
+  PRIMARY KEY (`Id`)
+) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;');
+    $this->Database->query("INSERT INTO `'.$this->UpdateManager->VersionTable.'` (`Id`, `Revision`) VALUES
+      (1, '.$DatabaseRevision.');");
+    $this->Database->query("CREATE TABLE IF NOT EXISTS `Module` (
+  `Id` int(11) NOT NULL AUTO_INCREMENT,
+  `Name` varchar(255) NOT NULL,
+  `Title` varchar(255) NOT NULL,
+  PRIMARY KEY (`Id`)
+) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;");
+  }
+
+  function Uninstall()
+  {
+    $this->System->ModuleManager->UninstallAll();
+    $this->Database->query('DROP TABLE `Module`');
+    $this->Database->query('DROP TABLE `'.$this->UpdateManager->VersionTable.'`');
+  }
+
+  function IsInstalled()
+  {
+    $DbResult = $this->Database->query('SHOW TABLES LIKE "'.$this->UpdateManager->VersionTable.'"');
+    return($DbResult->num_rows > 0);
+  }
+
+  function Upgrade()
+  {
+    $Updates = new Updates();
+    $this->UpdateManager->Trace = $Updates->Get();
+    $Output = $this->UpdateManager->Upgrade();
+    return($Output);
+  }
+}
Index: /trunk/Packages/Common/Table.php
===================================================================
--- /trunk/Packages/Common/Table.php	(revision 69)
+++ /trunk/Packages/Common/Table.php	(revision 69)
@@ -0,0 +1,192 @@
+<?php
+
+class Control
+{
+  var $Name;
+
+  function Show()
+  {
+    return('');
+  }
+}
+
+class Table
+{
+  function GetCell($Y, $X)
+  {
+    return('');
+  }
+
+  function BeginRead()
+  {
+  }
+
+  function EndRead()
+  {
+  }
+
+  function RowsCount()
+  {
+    return(0);
+  }
+}
+
+class TableMemory extends Table
+{
+  var $Cells;
+
+  function GetCell($Y, $X)
+  {
+    return($this->Cells[$Y][$X]);
+  }
+
+  function RowsCount()
+  {
+    return(count($this->Cells));
+  }
+}
+
+class TableSQL extends Table
+{
+  var $Query;
+  var $Database;
+  var $Cells;
+
+  function GetCell($Y, $X)
+  {
+    return($this->Cells[$Y][$X]);
+  }
+
+  function BeginRead()
+  {
+    $this->Cells = array();
+    $DbResult = $this->Database->query($this->Query);
+    while($DbRow = $DbResult->fetch_row())
+    {
+      $this->Cells[] = $DbRow;
+    }
+  }
+
+  function EndRead()
+  {
+    $this->Cells = array();
+  }
+
+  function RowsCount()
+  {
+    return(count($this->Cells));
+  }
+}
+
+class TableColumn
+{
+  var $Name;
+  var $Title;
+}
+
+class VisualTable extends Control
+{
+  var $Cells;
+  var $Columns;
+  var $OrderSQL;
+  var $OrderColumn;
+  var $OrderDirection;
+  var $OrderArrowImage;
+  var $DefaultColumn;
+  var $DefaultOrder;
+  var $Table;
+  var $Style;
+
+  function __construct(System $System)
+  {
+    $this->Columns = array();
+    $this->Table = new TableMemory();
+    $this->OrderDirSQL = array('ASC', 'DESC');
+    $this->OrderArrowImage = array($System->Link('/images/sort_asc.png'),
+      $System->Link('/images/sort_desc.png'));
+    $this->DefaultOrder = 0;
+    $this->Style = 'BaseTable';
+  }
+
+  function SetColumns($Columns)
+  {
+    $this->Columns = array();
+    foreach($Columns as $Column)
+    {
+      $NewCol = new TableColumn();
+      $NewCol->Name = $Column['Name'];
+      $NewCol->Title = $Column['Title'];
+      $this->Columns[] = $NewCol;
+    }
+    if(count($this->Columns) > 0)
+      $this->DefaultColumn = $this->Columns[0]->Name;
+      else $this->DefaultColumn = '';
+  }
+
+  function Show()
+  {
+    $Output = '<table class="'.$this->Style.'">';
+    $Output .= $this->GetOrderHeader();
+    $this->Table->BeginRead();
+    for($Y = 0; $Y < $this->Table->RowsCount(); $Y++)
+    {
+      $Output .= '<tr>';
+
+      for($X = 0; $X < count($this->Columns); $X++)
+      {
+        $Cell = $this->Table->GetCell($Y, $X);
+        if($Cell == '') $Output .= '<td>&nbsp;</td>';
+          else $Output .= '<td>'.$Cell.'</td>';
+      }
+      $Output .= '</tr>';
+    }
+    $this->Table->EndRead();
+    $Output .= '</table>';
+    return($Output);
+  }
+
+  function GetOrderHeader()
+  {
+    if(array_key_exists('OrderCol', $_GET)) $_SESSION['OrderCol'] = $_GET['OrderCol'];
+    if(array_key_exists('OrderDir', $_GET)) $_SESSION['OrderDir'] = $_GET['OrderDir'];
+    if(!array_key_exists('OrderCol', $_SESSION)) $_SESSION['OrderCol'] = $this->DefaultColumn;
+    if(!array_key_exists('OrderDir', $_SESSION)) $_SESSION['OrderDir'] = $this->DefaultOrder;
+
+    // Check OrderCol
+    $Found = false;
+    foreach($this->Columns as $Column)
+    {
+      if($Column->Name == $_SESSION['OrderCol'])
+      {
+        $Found = true;
+        break;
+      }
+    }
+    if($Found == false)
+    {
+      $_SESSION['OrderCol'] = $this->DefaultColumn;
+      $_SESSION['OrderDir'] = $this->DefaultOrder;
+    }
+    // Check OrderDir
+    if(($_SESSION['OrderDir'] != 0) and ($_SESSION['OrderDir'] != 1))
+      $_SESSION['OrderDir'] = 0;
+
+    $Result = '';
+    $QueryItems = GetQueryStringArray($_SERVER['QUERY_STRING']);
+    foreach($this->Columns as $Index => $Column)
+    {
+      $QueryItems['OrderCol'] = $Column->Name;
+      $QueryItems['OrderDir'] = 1 - $_SESSION['OrderDir'];
+      if($Column->Name == $_SESSION['OrderCol'])
+        $ArrowImage = '<img style="vertical-align: middle; border: 0px;" src="'.$this->OrderArrowImage[$_SESSION['OrderDir']].'" alt="order arrow">';
+        else $ArrowImage = '';
+      if($Column->Name == '') $Result .= '<th>'.$Column->Title.'</th>';
+        else $Result .= '<th><a href="?'.SetQueryStringArray($QueryItems).'">'.$Column->Title.$ArrowImage.'</a></th>';
+    }
+    $this->OrderSQL = ' ORDER BY `'.$_SESSION['OrderCol'].'` '.$this->OrderDirSQL[$_SESSION['OrderDir']];
+    $this->OrderColumn = $_SESSION['OrderCol'];
+    $this->OrderDirection = $_SESSION['OrderDir'];
+
+    return('<tr>'.$Result.'</tr>');
+  }
+}
Index: /trunk/Packages/Common/Update.php
===================================================================
--- /trunk/Packages/Common/Update.php	(revision 69)
+++ /trunk/Packages/Common/Update.php	(revision 69)
@@ -0,0 +1,83 @@
+<?php
+
+class UpdateManager
+{
+  var $Revision;
+  var $Trace;
+  var $VersionTable;
+  /* @var Database */
+  var $Database;
+  var $InstallMethod;
+
+  function __construct()
+  {
+    $this->Revision = 0;
+    $this->Trace = array();
+    $this->VersionTable = 'SystemVersion';
+    $this->InstallMethod = 'FullInstall';
+    $this->InsertSampleDataMethod = 'InsertSampleData';
+  }
+
+  function GetDbVersion()
+  {
+    $DbResult = $this->Database->select($this->VersionTable, '*', 'Id=1');
+    $Version = $DbResult->fetch_assoc();
+    return($Version['Revision']);
+  }
+
+  function IsInstalled()
+  {
+    $DbResult = $this->Database->query('SHOW TABLES LIKE "'.$this->VersionTable.'"');
+    return($DbResult->num_rows > 0);
+  }
+
+  function IsUpToDate()
+  {
+    return($this->Revision <= $this->GetDbVersion());
+  }
+
+  function Upgrade()
+  {
+    $DbRevision = $this->GetDbVersion();
+    $Output = 'Počáteční revize databáze: '.$DbRevision.'<br/>';
+    while($this->Revision > $DbRevision)
+    {
+      $TraceItem = $this->Trace[$DbRevision];
+      $Output .= 'Aktualizace na verzi '.$TraceItem['Revision'].':<br/>';
+      // Show applied SQL queries immediatelly
+      echo($Output);
+      $Output = '';
+      $RevUpdate = $TraceItem['Function'];
+      $RevUpdate($this);
+      $DbRevision = $TraceItem['Revision'];
+      $this->Database->query('UPDATE `'.$this->VersionTable.'` SET `Revision`= '.
+        $TraceItem['Revision'].' WHERE `Id`=1');
+    }
+    return($Output);
+  }
+
+  function Install()
+  {
+    $InstallMethod = $this->InstallMethod;
+    $InstallMethod($this);
+    $this->Update();
+  }
+
+  function Uninstall()
+  {
+
+  }
+
+  function InsertSampleData()
+  {
+    $InstallMethod = $this->InsertSampleDataMethod;
+    $InstallMethod($this);
+  }
+
+  function Execute($Query)
+  {
+    echo($Query.';<br/>');
+    flush();
+    return($this->Database->query($Query));
+  }
+}
